
// (c) COPYRIGHT URI/MIT 1997-98
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors: reza (Reza Nekovei)

// This is the main CGI program which extracts DAS class attributes from a
// FreeFrom data file. In addition, the attributes from an external file (if 
// exist, with the same name as the FreeFrom file and extension of .das at the 
// end) are extracted and added to the in-memory atrribute table before it is 
// sent over the network to the client side. 
//
// ReZa 6/28/97

// $Log: ff_das.cc,v $
// Revision 1.5  1998/08/12 21:21:09  jimg
// Massive changes from Reza. Compatible with the new FFND library
//
// Revision 1.4  1998/04/21 17:14:07  jimg
// Fixes for warnings, etc
//
// Revision 1.3  1998/04/16 18:11:23  jimg
// Sequence support added by Reza

#include "config_ff.h"

static char rcsid[] __unused__ ={"$Id: ff_das.cc,v 1.5 1998/08/12 21:21:09 jimg Exp $"};

#include <iostream.h>

#include "DAS.h"
#include "cgi_util.h"
#include "DODSFilter.h"

// These must be defined here to resolve symbols declared as extern in
// FFByte.cc, ... 8/12/98 jhrg

long BufPtr = 0; // cache pointer
long BufSiz =0; // Cache size
char *BufVal = NULL; // cache buffer

extern bool get_attributes(DAS &das, const char *filename, String *error);

int 
main(int argc, char * argv[])
{
    DAS das;
    DODSFilter df(argc, argv);

    if (!df.OK()) {
	df.print_usage();
	return 1;
    }

    if (df.version()) {
	df.send_version_info();
	return 0;
    }

    // Read the FreeFrom file attributes in memory and forward all the errors
    // to client program

    String errMsg;
    if(!get_attributes(das, df.get_dataset_name(), &errMsg)){
	Error *ErrorObj = new Error(no_such_file, errMsg);
	set_mime_text(cout, dods_error);
	ErrorObj->print();
	exit(1);
    }

    if (!df.read_ancillary_das(das))
	return 1;

    if (!df.send_das(das))
	return 1;

    return 0;
}



