
// (c) COPYRIGHT URI/MIT 1997-98
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors: reza (Reza Nekovei)

// This is the main CGI program which extracts DDS class descriptors from a
// FreeForm format file. In addition, the descriptors from an external file
// (if exist, with the same name as the data file and extension of .dds) are
// extracted and added to the in-memory DDS table before it is sent over the
// network to the client side.
//
// ReZa 6/20/97

// $Log: ff_dds.cc,v $
// Revision 1.6  1998/09/17 17:42:49  jimg
// Added installation of date_func in DDS.
//
// Revision 1.5  1998/08/12 21:21:10  jimg
// Massive changes from Reza. Compatible with the new FFND library
//
// Revision 1.4  1998/04/21 17:14:08  jimg
// Fixes for warnings, etc
//
// Revision 1.3  1998/04/16 18:11:23  jimg
// Sequence support added by Reza

#include "config_ff.h"

static char rcsid[] __unused__ ={"$Id: ff_dds.cc,v 1.6 1998/09/17 17:42:49 jimg Exp $"};

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <assert.h>

#include <iostream.h>

#include "DDS.h"
#include "cgi_util.h"
#include "DODSFilter.h"
#include "ce_functions.h"

// These must be defined here to resolve symbols declared as extern in
// FFByte.cc, ... 8/12/98 jhrg

long BufPtr = 0;		// Cache pointer
long BufSiz =0;			// Cache size
char *BufVal = NULL;		// Cache buffer

extern bool read_descriptors(DDS &dds, const char * filename, String *err_msg);

int 
main(int argc, char * argv[])
{
    DDS dds;
    dds.add_function("date", func_date);

    DODSFilter df(argc, argv);

    if (!df.OK()) {
	df.print_usage();
	return 1;
    }

    if (df.version()) {
	df.send_version_info();
	return 0;
    }

    // Read the file dataset descriptor in memory
    String errMsg;
    if(!read_descriptors(dds, df.get_dataset_name(), &errMsg)){
	ErrMsgT("ff_dds: could not read the DDS information");
	//client error message
	Error e(unknown_error, errMsg);
	set_mime_text(cout, dods_error);
	e.print(cout);
	return 1;
    }

    if (!df.read_ancillary_dds(dds))
	return 1;

    if (!df.send_dds(dds, true))
	return 1;

    return 0;
}
